/* send_sysrq - send remote sysrq over udp */

#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <netdb.h>
#include <time.h>

#include "password.h"

#define	PORT	9

unsigned int pass2int( char *pass )
{ unsigned int p=0;
  unsigned int i=0;
	while( *pass )
	{	switch( i & 0x03 )
		{	case 0:
				p+=(*pass)<<24;
				break;
			case 1:
				p+=(*pass)<<16;
				break;
			case 2:
				p+=(*pass)<<8;
				break;
			case 3:
				p+=(*pass);
				break;
		}
		i++;
		pass++;
	}
	return(p);
}

#define	RANDGEN	(s=s*a+b)
#define	RAND	(((RANDGEN)>>24)&0x00ff)
int send_udp( unsigned int ip, int port, char c, char *pass )
{ int sock;
  struct sockaddr_in addr;
  char buf[128];
  int len,i,crc;

/* PASSWORD ;-) */
  unsigned int a = RSYSRQ_A;
  unsigned int b = RSYSRQ_B;
  unsigned int s = pass2int(pass);

	len= ((((time(NULL)*5)^(getpid()*7))>>3)&0x7c)+2 ;

printf("len=%d\n",len);
	for(i=0;i<len;i++)
	{	RANDGEN;RANDGEN;RANDGEN;
// printf("%08x\n",s);
	}

	buf[0]=c;
	for(i=1;i<len-1;i++)
		buf[i]=0;
	crc=0;
	for(i=0;i<len-1;i++)
		crc+=buf[i];
	buf[len-1]=((crc>>8)+crc)&0x00ff;
/*
	for(i=0;i<len;i++)
		printf("0x%02x ",buf[i]&0x00ff);
	printf("\n");
*/
	for(i=0;i<len;i++)
		buf[i]^=RAND;

/*
	for(i=0;i<len;i++)
		printf("0x%02x ",buf[i]&0x00ff);
	printf("\n");
*/

	sock=socket(PF_INET,SOCK_DGRAM,0);
	addr.sin_family = AF_INET;
	addr.sin_addr.s_addr= ip;
	addr.sin_port=htons(port);
	if( sendto(sock,buf,len,0,(struct sockaddr*)&addr,sizeof(struct sockaddr_in))<0 )
	{	close(sock);
		return(-1);
	}
	close(sock);
	return(0);
}

#define	iaddr_c2i(c)	(*(int *)(c))

int net_name2ip(char *name, unsigned int *ip)
{ struct hostent *he;
	if(!name[0])
	{	*ip=(unsigned int)inet_addr ("127.0.0.1");
		return(1);
	}
	if( (*ip=(unsigned int)inet_addr(name))!=(unsigned int)(-1) )
		return(1);
	if( (he=gethostbyname(name))==NULL )
		return(0);
	*ip=(unsigned int)iaddr_c2i(he->h_addr);
	return(1);
}

int main( int argc, char *argv[] )
{ char *addr=NULL;
  char *cmds=NULL;
  char *pass;
  char *pass2;
  unsigned int ip;
  int r;

	if( argc!=3 )
	{	printf("usage: %s <host> <cmds>\n",argv[0]);
		return(0);
	}
	addr=argv[1];
	cmds=argv[2];

	net_name2ip(addr,&ip);

	for(;;)
	{
		pass2=strdup(getpass("Enter password: "));
		pass=getpass("ReEnter password: ");

		if( !strcmp(pass2,pass) )
			break;
		printf("Don't match!\n\n");
		free(pass2);
	}
	free(pass2);

	if( !strcmp(cmds,"---") )
	{	FILE *f;
		if( (f=fopen("password.h","w"))!=NULL )
		{
			fprintf(f,"\n#define\tRSYSRQ_A\t%d\n#define\tRSYSRQ_B\t%d\n#define\tRSYSRQ_S\t0x%08x\n\n",RSYSRQ_A,RSYSRQ_B,pass2int(pass));
			fclose(f);
		}
		else
			printf("Can't open file password.h for writing\n");
		return(0);
	}

	while( *cmds )
	{
		if( *cmds=='-' )
		{
			sleep(2);
		}
		else
		{
			r=send_udp(ip,PORT,*cmds,pass);
			sleep(1);
			r=send_udp(ip,PORT,*cmds,pass);
			sleep(1);
		}
		cmds++;
	}
	return(r);
}

